function [intFF, intFuFu, intFuFv, intFvFu, intFvFv] = int_form_func(fem_deg)
% [intFF, intFuFu, intFuFv, intFvFu, intFvFv] = int_form_func(fem_deg)
% integral of form functions over unit trianlge
% intFF(i, j) is the integral of F(i) * F(j) over a unit triangle
% F(i) has the value of 1 at point i and zero on all other points
% fem_deg is the fem_degree of F
% the u and v coordinates of the points are:
%      1  2  3  4    5    6
% u = [0, 0, 1, 0,   0.5, 0.5];
% v = [0, 1, 0, 0.5, 0.5, 0];

[FF, FuFu, FuFv, FvFu, FvFv] = form_func(fem_deg);

syms u v real;
intFF =   double(int(int(FF,   u, 0, 1-v), v, 0, 1));
intFuFu = double(int(int(FuFu, u, 0, 1-v), v, 0, 1));
intFuFv = double(int(int(FuFv, u, 0, 1-v), v, 0, 1));
intFvFu = double(int(int(FvFu, u, 0, 1-v), v, 0, 1));
intFvFv = double(int(int(FvFv, u, 0, 1-v), v, 0, 1));

