function [shape] = run_fem_d_n(shape, max_num_evecs, fem_deg)
% run fem for dirichlet & neumann
tic;
[A, B, shape] = calc_A_B(shape, fem_deg);
tc=toc;
fprintf('done calc_A_B(%6.2f sec)\n', tc);

[shape.d.evecs, shape.d.evals] = fem(shape, 'dir', max_num_evecs, fem_deg, A, B);
display('done fem shape d');
[shape.n.evecs, shape.n.evals] = fem(shape, 'neu', max_num_evecs, fem_deg, A, B);
display('done fem shape n');


end % function run_fem_d_n
