function [boundary_vertex_idx, bound_len] = calc_shape_boundary(shape)
% return the vertices of edges that are only in one triangle

[AB, AC, BC] = tri_edge_idx(shape.TRIV);
edges = [AB; AC; BC];
edges = sort(edges, 2);
edges = sortrows(edges);
n = size(edges, 1);

top = [n, 1:(n-1)];
cen = 1:n;
bot = [2:n, 1];

is_boundary_edge = any(edges(cen, :) ~= edges(top, :), 2) & any(edges(cen, :) ~= edges(bot, :), 2);
boundary_edge_idx = edges(is_boundary_edge, :);

boundary_vertex_idx = boundary_edge_idx(:);
boundary_vertex_idx = unique(boundary_vertex_idx(:));


boundary_edge.xyz1 = [shape.X(boundary_edge_idx(:,1)), shape.Y(boundary_edge_idx(:,1)), shape.Z(boundary_edge_idx(:,1))];
boundary_edge.xyz2 = [shape.X(boundary_edge_idx(:,2)), shape.Y(boundary_edge_idx(:,2)), shape.Z(boundary_edge_idx(:,2))];
bound_len = sum(norm_row(boundary_edge.xyz1 - boundary_edge.xyz2));
