function [shape] = make_holes(shape)
% shape.shape0 is WITHOUT holes, has the fields: X, Y, Z, TRIV
% shape.shape1 is WITH holes, has the fields: X, Y, Z, TRIV
% the fields X, Y, Z and TRIV are removed from shape

shape.num_holes = numel(shape.src0);
assert(shape.num_holes && shape.hole_size);
shape.name = sprintf('%s_%02d_%02d', shape.name, shape.num_holes, shape.hole_size);

do_geodesic_contour = 0;

if (do_geodesic_contour)
    shape = prep_holes(shape);

    if(0)
        plot_shape_labels(shape);
    end
else
    d = d_shape(shape, shape.src0);
end
    
[shape.shape0.X, shape.shape0.Y, shape.shape0.Z, shape.shape0.TRIV]  = deal(shape.X, shape.Y, shape.Z, shape.TRIV);
shape = rmfield(shape, {'X', 'Y', 'Z', 'TRIV'});

if (do_geodesic_contour)
    shape.shape1 = tri_remove(shape.shape0, shape.tri_labels == 1);
else
    vertex_remove_idx = find(d < shape.hole_size);
    shape.shape1 = vertex_remove(shape.shape0, vertex_remove_idx);
end

end % function make_holes

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [] = plot_shape_labels(shape)
num_vert = size(shape.X, 1);
ver_labels = (tri2vert(shape.TRIV, num_vert) * shape.tri_labels) ~= 0;
figure; trisurf(shape.TRIV, shape.X, shape.Y, shape.Z, double(ver_labels),'EdgeColor', 'interp', 'FaceColor', 'interp', 'BackFaceLighting', 'unlit');
title('shape labels');
shading interp; lighting phong; camlight head; material dull; axis image; axis off;
end % function plot_shape_labels
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

