function [shape] = unite_close_vertices(shape)

quan_param = 1e-6;

shape_XYZ = [shape.X, shape.Y, shape.Z];
floor_XYZ = floor(shape_XYZ);
rem_XYZ =  shape_XYZ - floor_XYZ;
rem_XYZ = round(rem_XYZ/quan_param)*quan_param;
shape_XYZ = floor_XYZ + rem_XYZ;
[shape_XYZ, idx, new_map] = unique(shape_XYZ, 'rows');
num_vert_orig = length(shape.X);
[shape.X, shape.Y, shape.Z] = deal(shape.X(idx), shape.Y(idx), shape.Z(idx));
num_vert = length(shape.X);
display(sprintf('unite_close_vertices removed %d / %d vertices, %d', num_vert_orig - num_vert, num_vert_orig));

%assert(max(max(abs(shape_XYZ - [shape.X, shape.Y, shape.Z]))) <= quan_param);

shape.TRIV = new_map(shape.TRIV);

tri_remove_idx = (shape.TRIV(:, 1) == shape.TRIV(:, 2)) | (shape.TRIV(:, 1) == shape.TRIV(:, 3)) | (shape.TRIV(:, 2) == shape.TRIV(:, 3));
display(sprintf('unite_close_vertices removed %d / %d triangles', sum(tri_remove_idx), length(tri_remove_idx)));
shape.TRIV(tri_remove_idx, :) = [];

if(isfield(shape, 'tri_labels'))
    shape.tri_labels(tri_remove_idx, :) = [];
end

vertex_remove_idx = setdiff([1:num_vert]', shape.TRIV(:));
display(sprintf('unite_close_vertices removed %d vertices, %d', length(vertex_remove_idx)));
[shape, tri_remove_idx] = vertex_remove(shape, vertex_remove_idx);

if(isfield(shape, 'tri_labels'))
    shape.tri_labels(tri_remove_idx, :) = [];
end
