function [shape, tri_remove_idx] = vertex_remove(shape, vertex_remove_idx)

assert(all(vertex_remove_idx > 0));

num_vert_old = numel(shape.X);

shape.X(vertex_remove_idx) = []; shape.Y(vertex_remove_idx) = []; shape.Z(vertex_remove_idx) = [];
num_vert_new = numel(shape.X);

vertex_keep_idx = 1:num_vert_old;
vertex_keep_idx(vertex_remove_idx) = [];
new_map = zeros(1, num_vert_old);
new_map(vertex_keep_idx) = 1:num_vert_new;

tri_remove_idx = ismember(shape.TRIV(:, 1), vertex_remove_idx) | ...
    ismember(shape.TRIV(:, 2), vertex_remove_idx) | ...
    ismember(shape.TRIV(:, 3), vertex_remove_idx);
shape.TRIV(tri_remove_idx, :) = [];

shape.TRIV = new_map(shape.TRIV);

assert(max(shape.TRIV(:)) <= length(shape.X));
assert(min(shape.TRIV(:)) > 0);
%figure; trimesh(shape.TRIV, shape.X, shape.Y, shape.Z); title('mesh without the removed idx');
