SHAPES = dir(fullfile(EVECS_DIR, FILES_TO_PROCESS));
SHAPES = {SHAPES.name};

% Statistics
tic;
nerr  = 0;
nskip = 0;
nok   = 0;
fprintf(1, 'Computing diffusion kernels...\n');


warning off;
for k=1:size(KERNELS,1),
    mkdir([KERNEL_DIR '.' KERNELS{k,2}]);
end
warning on;

for s = 1:length(SHAPES), 
    
    shapename = SHAPES{s};
    fprintf(1, '  %-30s \t ', shapename);

    % Load eigendecomposition
    load(fullfile(EVECS_DIR, shapename), 'evecs', 'evals', 'A');
    
    for k=1:size(KERNELS,1),
        T = KERNELS{k,3};
        K = {};
        kernelfun = KERNELS{k,1};
        if SKIP_EXISTING && exist(fullfile([KERNEL_DIR '.' KERNELS{k,2}], shapename), 'file'),
           nskip = nskip+1;
           continue;
        end        
        for t = 1:length(T),
            K{t} = kernel(@(w)(kernelfun(w,T(t))), evals, evecs);
        end
        save(fullfile([KERNEL_DIR '.' KERNELS{k,2}], shapename), 'K', 'T');
        clear K;
        nok = nok+1;
    end
    
    % Save result
    fprintf(1, 'OK\n');
     
end

% Statistics
fprintf(1, '\nComputation complete\n');
fprintf(1, ' Elapsed time:      %s\n', format_time(toc));
fprintf(1, ' Total shapes:      %d\n', length(SHAPES));
fprintf(1, ' Kernels computed:  %d\n', nok);
fprintf(1, ' Kernels skipped:   %d\n', nskip);
fprintf(1, ' Errors:            %d\n', nerr);

