function [dist,d] = diffdist(fast, D,A,dmax,nbins,sigma)

AA = bsxfun(@times, A(:), A(:)');
AA = AA/sum(AA(:));


%dmax  = max(D(:));
if nargin < 5, nbins = 256;         end
if nargin < 6, sigma = dmax/nbins;  end
if dmax <= 0, dmax = 1; end

if fast,
    
    dn = D/dmax*(nbins-1);
    n0 = floor(dn);
    dn = dn - n0;
    
    idx = find(n0 >= nbins-1);
    n0(idx) = nbins-1;
    dn(idx) = 0;
    n0 = uint32(n0);

    h0 = whistint( uint32(n0(:)),   AA(:).*(1-dn(:)), nbins+1 );
    h1 = whistint( uint32(n0(:)), AA(:).*dn(:)    , nbins+1 );

    dist = h0(1:nbins) + h1(1:nbins);

else
    
    d = [0:dmax/(nbins-1):dmax];
    dist = zeros(nbins,1);
    for n=1:nbins,
        dist(n) = AA(:)'*exp(-(D(:)-d(n)).^2/2/sigma^2);
    end

end

