
#include <mex.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	int n = mxGetM(prhs[0]);
	int K = mxGetN(prhs[0]);

    double *V = mxGetPr(prhs[0]);
    
    mwSize dims[2];
	dims[0] = n; dims[1] = n;
    plhs[0] = mxCreateNumericArray(2, dims, mxDOUBLE_CLASS, mxREAL);
    double *D = mxGetPr(plhs[0]);  
    
    for (int j=0; j < n; j++)
    {
        for (int i=j+1; i < n; i++)
        {
            double d = 0.0;
            double *L = mxGetPr(prhs[1]);
            for (int k=0; k < K; k++)
            {
                double vi = V[k*n+i];
                double vj = V[k*n+j];                
                d += (vi-vj)*(vi-vj)*(*L++);
            }
            D[i*n+j] = D[j*n+i] = d;
        }
    }
}

