% Computes ground truth correspondences between positive shapes
%
% (C) Copyright Alex Bronstein, Michael Bronstein, Maks Ovsjanikov,
% Stanford University, 2009. All Rights Reserved.


if ~SKIP_EXISTING || (SKIP_EXISTING && ~exist(fullfile(GROUNDTRUTH_DIR, 'translation_table'), 'file')),

    XLUT = {};
    str = '';
    fprintf(1, 'Computing groundtruth correspondences...\n');
    for n = 1:MAX_POSITIVE_SHAPES,

        XLUT{n} = {};
        SHAPES = dir(fullfile(DESC_DIR, sprintf('%04d.*.mat', n)));
        SHAPES = {SHAPES.name};

        try,
            ref = fullfile(EVECS_DIR, sprintf('%04d.null.0.mat', n));
            load(ref, 'shape');
            SHAPE0 = shape;
        catch
            continue;
        end

        % Compute all-to-all LUTs
        for ii = 1:length(SHAPES),
            load(fullfile(EVECS_DIR, SHAPES{ii}), 'LUT', 'shape');
            LUT1 = LUT;
            for jj = 1:length(SHAPES),
                str = mprintf(str, '%-4d %30s --> %s', n, SHAPES{ii}, SHAPES{jj});
                load(fullfile(EVECS_DIR, SHAPES{jj}), 'LUT');
                LUT2 = LUT;
                ILUT = zeros(length(SHAPE0.X), 1);
                ILUT(LUT2) = 1:length(LUT2);
                XLUT{n}{ii,jj} = ILUT(LUT1);
            end
        end

    end

    % Save
    save(fullfile(GROUNDTRUTH_DIR, 'translation_table'), 'XLUT');
    mprintf(str, 'Completed\n\n');

end
