function SHAPES = generate_xforms(shape,xform,flag,varargin)

maxstrength = varargin{1};

switch lower(xform)
    
    case 'partial'

        shape0 = shape;
        % Remove non-manifold vertices and vertices shared by too many triangles
        [h,hb,hnm] = boundary_vertices(shape);
        [t] = tri_per_vert(shape);
        shape = reindex_mesh(shape, find(t<15 & hnm==0), []);

        % Rotation around Z
        SHAPES = xform_partial(shape, maxstrength, 0, 0);

        shape_ = shape;
        shape_.X = shape.Z;
        shape_.Z = shape.X;
        SHAPES = xform_partial(shape_, maxstrength, 80, 1);
        for k=1:length(SHAPES),
            x = SHAPES{k}.X;
            SHAPES{k}.X = SHAPES{k}.Z;
            SHAPES{k}.Z = x;
            
            if flag
                [SHAPES{k}.t,SHAPES{k}.u] = find_corr(SHAPES{k},shape0);
            end
        end

 
    
        
    case 'noise'
        SHAPES = xform_gaussnoise(shape, varargin{2:3}, maxstrength, flag);


    case 'shotnoise'
        SHAPES = xform_shotnoise(shape, varargin{2:5}, maxstrength, flag);

        
    case 'microholes'
        SHAPES = xform_microholes(shape, varargin{2:3}, maxstrength, flag);

        
    case 'holes'
        SHAPES = xform_holes(shape, varargin{2:3}, maxstrength, flag);

        
    case 'sampling'
        SHAPES = xform_sampling(shape, varargin{2:3}, maxstrength, flag);
        

    case 'localscale'
        SHAPES = xform_localscale(shape, varargin{2:7}, maxstrength, flag);


    case 'scale'
        SHAPES = xform_scale(shape, varargin{2:3}, maxstrength, flag);
        

    case 'all'
        SHAPES = xform_all(shape, varargin{2:15}, maxstrength, flag);

        
    case 'topology'
        SHAPES = xform_topology(shape, varargin{2:9}, maxstrength, flag);
        
        
end

return

        


