function SHAPES = xform_all(shape, minholes, maxholes, minholesm, maxholesm, minsigma, maxsigma, minsigmas, maxsigmas, minpoints, maxpoints, minscale, maxscale, mindensity, maxdensity, maxstrength, flag)

SHAPES = {};


for strength = 1:maxstrength,
    
    if maxstrength == 1
        lambda = 0;
    else
        lambda = (strength-1)/(maxstrength-1);
    end
    
    shape_ = xform_sampling(shape, mindensity*(1-lambda) + maxdensity*lambda, mindensity*(1-lambda) + maxdensity*lambda, 1, 0);
    shape_ = xform_holes(shape_{1}, round(minholes*(1-lambda) + maxholes*lambda), round(minholes*(1-lambda) + maxholes*lambda), 1, 0);
    shape_ = xform_microholes(shape_{1}, round(minholesm*(1-lambda) + maxholesm*lambda), round(minholesm*(1-lambda) + maxholesm*lambda), 1, 0);
  
    % find correspondence
    if flag
        [t,u] = find_corr(shape,shape_{1});
    end

    scale = minscale*(1-lambda) + maxscale*lambda;
    shape_ = xform_scale(shape_{1}, minscale*(1-lambda) + maxscale*lambda, minscale*(1-lambda) + maxscale*lambda, 1, 0);    
    
    shape_ = xform_gaussnoise(shape_{1}, (minsigma*(1-lambda) + maxsigma*lambda)*scale, (minsigma*(1-lambda) + maxsigma*lambda)*scale, 1, 0);
    
    shape_ = xform_shotnoise(shape_{1}, (minsigmas*(1-lambda) + maxsigmas*lambda)*scale, (minsigmas*(1-lambda) + maxsigmas*lambda)*scale,...
                              round(minpoints*(1-lambda) + maxpoints*lambda), round(minpoints*(1-lambda) + maxpoints*lambda), 1, 0);
    
     
    shape_{1}.u = u;
    shape_{1}.t = t;
    SHAPES{strength} = shape_{1};
    
end



