function SHAPES = xform_gaussnoise(shape, minsigma, maxsigma, maxstrength, flag)

N = randn(length(shape.X), 1);
[Nt,Nv] = normals(shape.TRIV, [shape.X shape.Y shape.Z]);
N = bsxfun(@times, Nv, N);

SHAPES = {};
for strength = 1:maxstrength,
    
    % Hole settings
    if maxstrength == 1
        lambda = 0;
    else
        lambda = (strength-1)/(maxstrength-1);
    end
    
    sigma  = minsigma*(1-lambda)+maxsigma*lambda;

    shape1 = shape;
    shape1.X = shape1.X + N(:,1)*sigma;
    shape1.Y = shape1.Y + N(:,2)*sigma;
    shape1.Z = shape1.Z + N(:,3)*sigma;

    % find correspondence - trivial
    if flag
        [shape1.t,shape1.u] = find_corr(shape);
    end

    
    SHAPES{strength} = shape1;
end
